﻿Module CommandProcessor

    Structure Command
        Dim CommmandName As String
        Dim Params() As String
    End Structure

    Function ProcessCommand(ByVal CmdString As String, ByVal EnableComments As Boolean, ByVal LCaseCommand As Boolean, ByVal LCaseParams As Boolean) As Command
        ' Инициализация структуры
        Dim Result As New Command
        ' Чтение строки и названия команды
        Dim CS As String = Trim(CmdString)
        If Len(CS) = 0 Then Return Result
        If CS.Chars(0) = "#" And EnableComments Then Return Result
        Dim Pos As Integer = InStr(CS, " ")
        If Pos = 0 Then
            Result.CommmandName = StrLCase(CS, LCaseCommand)
            Return Result
        Else
            Result.CommmandName = StrLCase(Left(CS, Pos - 1), LCaseCommand)
            CS = Mid(CS, Pos)
        End If
        ' Подготовка параметров
        ReDim Result.Params(0)
        ' Разбиение на параметры
        Dim I As Integer
        Dim CurChar As String = ""
        Dim Quotes As Boolean = False
        Dim LastQuote As Boolean
        With Result
            For I = 1 To CS.Length
                LastQuote = (CurChar = """")
                CurChar = Mid(CS, I, 1)
                If CurChar = " " Then
                    If Quotes Then GoTo 1
                    If .Params(.Params.Length - 1) <> "" Then ReDim Preserve .Params(.Params.Length)
                    Continue For
                End If
                If CurChar = """" Then
                    Quotes = Not Quotes
                    If Not LastQuote And Quotes And .Params(.Params.Length - 1) <> "" Then Err.Raise(-1, , "Ошибка в формате команды")
                    If LastQuote And Quotes Then GoTo 1
                    Continue For
                End If
                If Not Quotes And LastQuote Then Err.Raise(-1, , "Ошибка в формате команды")
1:              .Params(.Params.Length - 1) += LCase(CurChar)
            Next
        End With
        ' Возврат результата
        Return Result
    End Function

    Function StrLCase(ByVal Str As String, ByVal UseLCase As Boolean) As String
        If UseLCase Then Return LCase(Str) Else Return Str
    End Function

    Function FindServerByName(ByVal Name As String) As CApplication
        For Each objApp As CApplication In Apps
            If StrComp(objApp.Name, Name, CompareMethod.Text) = 0 Then Return objApp
        Next
        Return Nothing
    End Function

End Module
