﻿Module CommandSystem

    Private CommandRunning As Boolean

    Private pRestartAll As Byte = 1
    Private pDisableAll As Byte = 1
    Private pEnableAll As Byte = 1
    Private pRestart As Byte = 1
    Private pDisable As Byte = 1
    Private pEnable As Byte = 1
    Private pFullRestart As Byte = 2
    Private pQuit As Byte = 255

    Private Const LocalName As String = "Локальная консоль"
    Private Const LocalLevel As Byte = 255

    Private Const CommandCheckInterval As Integer = 50

    Private CommandSystemThread As Thread

    Private CommandQueue As New Collection

    Private Structure CommandQuery
        Dim Cmd As String
        Dim Aggressor As String
        Dim AccessLevel As Byte
    End Structure

    Private Sub CommandSystemThreadProc()
        On Error GoTo ErrorHandler
        Do While True
            While CommandQueue.Count <> 0
                Dim Q As CommandQuery
                Q = CommandQueue.Item(1)
                CommandQueue.Remove(1)
                MangoRestartCommand(Q)
            End While
            Thread.Sleep(CommandCheckInterval)
        Loop
ErrorHandler:
        HandleCrash(Err, Err.GetException, "Сбой в CommandSystem")
    End Sub

    Public Sub CommandSystemStart()
        If Not IsNothing(CommandSystemThread) Then Return
        CommandSystemThread = New Thread(AddressOf CommandSystemThreadProc)
        CommandSystemThread.Start()
    End Sub

    Public Sub CommandSystemStop()
        If Not IsNothing(CommandSystemThread) Then CommandSystemThread.Abort()
        CommandSystemThread = Nothing
    End Sub

    Public Sub PutCommandToQueue(ByVal Command As String, Optional ByVal Aggressor As String = LocalName, Optional ByVal AccessLevel As Byte = LocalLevel)
        Dim Q As CommandQuery
        Q.Cmd = Command
        Q.Aggressor = Aggressor
        Q.AccessLevel = AccessLevel
        CommandQueue.Add(Q)
    End Sub

    Private Sub MangoRestartCommand(ByVal Q As CommandQuery)
        On Error GoTo E1
        Do While CommandRunning
            My.Application.DoEvents()
        Loop
        CommandRunning = True
        Dim CmdStr As String = Trim(Q.Cmd)
        If Left(CmdStr, 1) = "!" Then
            OutLog(NewCData(Q.Aggressor & ": " & Mid(CmdStr, 2), cfontChat), TimeStamp)
            PlaySound(ChatSound)
            GoTo Ex
        End If
        Dim Inst As Command
        OutLog(NewCData(Q.Aggressor & ": " & CmdStr, cfontEcho), TimeStamp)
        Inst = ProcessCommand(CmdStr, False, True, True)
        Select Case Inst.CommmandName
            Case "help"
                ShowCommandList()
            Case "restartall"
                If Q.AccessLevel < pRestartAll Then GoTo E2
                RestartServers()
            Case "disableall"
                If Q.AccessLevel < pDisableAll Then GoTo E2
                ShutdownServers()
            Case "enableall"
                If Q.AccessLevel < pEnableAll Then GoTo E2
                StartServers()
            Case "restart"
                If Q.AccessLevel < pRestart Then GoTo E2
                FindServerByName(Inst.Params(0)).SafeRestart()
            Case "disable"
                If Q.AccessLevel < pDisable Then GoTo E2
                FindServerByName(Inst.Params(0)).SafeKill(CApplication.KillMode.kmForever)
            Case "enable"
                If Q.AccessLevel < pEnable Then GoTo E2
                FindServerByName(Inst.Params(0)).ThreadStart()
            Case "quit"
                If Q.AccessLevel < pQuit Then GoTo E2
                ShutdownAll(False)
            Case "fullrestart"
                If Q.AccessLevel < pFullRestart Then GoTo E2
                Dim dR As New frmMain.deleg_Restart(AddressOf MainWindow.Restart)
                MainWindow.Invoke(dR)
            Case Else
                OutLog(NewCData(Q.Aggressor & ": ", cfontEcho), NewCData("Неизвестня команда: " & Inst.CommmandName, cfontError))
                GoTo Ex
        End Select
        OutLog(NewCData(Q.Aggressor & ": ", cfontEcho), NewCData("Успешно выполнено: " & Q.Cmd, cfontNormal))
        GoTo Ex
E1:     OutLog(NewCData(Q.Aggressor & ": ", cfontEcho), NewCData("Ошибка выполнения: " & Q.Cmd, cfontError))
        GoTo Ex
E2:     OutLog(NewCData(Q.Aggressor & ": ", cfontEcho), NewCData("Недостаточно привилегий для выполнения команды: " & Q.Cmd, cfontError))
Ex:     CommandRunning = False
    End Sub

    Public Sub ShowCommandList()
        OutLog()
        OutLog(NewCData("Консольные команды:", cfontMarked))
        OutLog(NewCData("! - комментарий, который позволяет администраторам общатся в консоли", cfontChat))
        ShowCommand("Help", 0, "Показать этот список команд")
        ShowCommand("RestartAll", pRestartAll, "Перезапустить все сервера")
        ShowCommand("DisableAll", pDisableAll, "Завершить все сервера")
        ShowCommand("EnableAll", pEnableAll, "Запустить все сервера")
        ShowCommand("Enable ""name""", pEnable, "Запустить сервер")
        ShowCommand("Disable ""name""", pDisable, "Завершить сервер")
        ShowCommand("Restart ""name""", pRestart, "Перезапустить сервер")
        ShowCommand("FullRestart", pRestart, "Перезапуск рестартера с перезагрузкой конфигурации")
        ShowCommand("Quit", pQuit, "Завершить все сервера и MangoRestart")
        OutLog()
    End Sub

    Private Sub ShowCommand(ByVal CmdName As String, ByVal Privilege As Byte, Optional ByVal Description As String = "")
        OutLog(NewCData(CmdName, cfontWarning), NewCData(" - " & Description & " (Уровень: " & Privilege & ")", cfontNormal))
    End Sub

End Module
