﻿Module Configuration

    Public Const MaxLogStrLength As Short = 256

    Private Const ConfigurationFile As String = "MangoRestart.conf"

    Public ConfigDump As String

    Public Function LoadSettings() As Boolean
        On Error GoTo E1
        Dim FileNumber As Integer = FreeFile()
        Dim FileName As String = My.Computer.FileSystem.CombinePath(My.Application.Info.DirectoryPath, ConfigurationFile)
        ' Открываем файл
        FileOpen(FileNumber, FileName, OpenMode.Input, OpenAccess.Read, OpenShare.LockWrite)
        On Error GoTo E2
        Dim ConfStr As String
        Dim Cmd As Command
        Dim StrNum As Integer = 0
        ConfigDump = ""
        Do Until EOF(FileNumber)
            ' Считываем строку
            ConfStr = LineInput(FileNumber)
            StrNum += 1
            ConfigDump += ConfStr & vbCrLf
            ' Разбиваем команду на параметры
            Cmd = ProcessCommand(ConfStr, True, True, False)
            ' Обрабатываем команду
            Select Case Cmd.CommmandName
                Case "checkinterval"
                    CheckInterval = Cmd.Params(0)
                Case "pinginterval"
                    PingInterval = Cmd.Params(0)
                Case "timebetweenpings"
                    TimeBetweenPings = Cmd.Params(0)
                Case "appclosetime"
                    AppCloseTime = Cmd.Params(0)

                Case "enableballoons"
                    EnableBalloons = True
                    BalloonsTimeOut = Cmd.Params(0)

                Case "servercrashedsound"
                    If Trim(Cmd.Params(0)) = "" Then Continue Do
                    Dim FullPath As String = My.Computer.FileSystem.CombinePath(My.Application.Info.DirectoryPath, Trim(Cmd.Params(0)))
                    If Not My.Computer.FileSystem.FileExists(FullPath) Then Err.Raise(-1, , "Файл не существует")
                    ServerCrashedSound = FullPath
                Case "serverstartedsound"
                    If Trim(Cmd.Params(0)) = "" Then Continue Do
                    Dim FullPath As String = My.Computer.FileSystem.CombinePath(My.Application.Info.DirectoryPath, Trim(Cmd.Params(0)))
                    If Not My.Computer.FileSystem.FileExists(FullPath) Then Err.Raise(-1, , "Файл не существует")
                    ServerStartedSound = FullPath
                Case "serverstartfailedsound"
                    If Trim(Cmd.Params(0)) = "" Then Continue Do
                    Dim FullPath As String = My.Computer.FileSystem.CombinePath(My.Application.Info.DirectoryPath, Trim(Cmd.Params(0)))
                    If Not My.Computer.FileSystem.FileExists(FullPath) Then Err.Raise(-1, , "Файл не существует")
                    ServerStartFailedSound = FullPath
                Case "mangorestartcrashedsound"
                    If Trim(Cmd.Params(0)) = "" Then Continue Do
                    Dim FullPath As String = My.Computer.FileSystem.CombinePath(My.Application.Info.DirectoryPath, Trim(Cmd.Params(0)))
                    If Not My.Computer.FileSystem.FileExists(FullPath) Then Err.Raise(-1, , "Файл не существует")
                    MangoRestartCrashedSound = FullPath
                Case "chatsound"
                    If Trim(Cmd.Params(0)) = "" Then Continue Do
                    Dim FullPath As String = My.Computer.FileSystem.CombinePath(My.Application.Info.DirectoryPath, Trim(Cmd.Params(0)))
                    If Not My.Computer.FileSystem.FileExists(FullPath) Then Err.Raise(-1, , "Файл не существует")
                    ChatSound = FullPath

                Case "errorwindow"
                    If Trim(Cmd.Params(0)) = "" Then Err.Raise(-1)
                    ReDim Preserve ErrWindows(ErrWindows.Length)
                    ErrWindows(ErrWindows.Length - 1) = Cmd.Params(0)

                Case "logerror"
                    If Trim(Cmd.Params(0)) = "" Then Err.Raise(-1, , "Некорректное значение параметра")
                    If Cmd.Params(0).Length > MaxLogStrLength Then Err.Raise(-1, , "Значение параметра слишком длинное")
                    ReDim Preserve LogStrings(LogStrings.Length)
                    LogStrings(LogStrings.Length - 1) = Cmd.Params(0)

                Case "appusemysql"
                    With Apps(Apps.Length - 1)
                        ConfigureMysqlSession(.LoginConnectionString, .LoginDb, .Name, Cmd.Params(0))
                        ConfigureMysqlSession(.WorldConnectionString, .WorldDb, .Name, Cmd.Params(0))
                        ConfigureMysqlSession(.CharactersConnectionString, .CharactersDb, .Name, Cmd.Params(0))
                    End With

                Case "app"
                    ReDim Preserve Apps(Apps.Length)
                    Apps(Apps.Length - 1) = New CApplication
                    With Apps(Apps.Length - 1)
                        ' Название
                        .Name = Cmd.Params(0)
                        ' Путь к исполняемому файлу
                        Dim FullPath As String = My.Computer.FileSystem.CombinePath(My.Application.Info.DirectoryPath, Trim(Cmd.Params(1)))
                        If Not My.Computer.FileSystem.FileExists(FullPath) Then Err.Raise(-1, , "Файл не существует")
                        .FilePath = FullPath
                        ' Рабочий каталог
                        .WorkingDir = My.Computer.FileSystem.GetParentPath(FullPath)
                        ' Путь к файлу конфигурации
                        FullPath = My.Computer.FileSystem.CombinePath(.WorkingDir, Trim(Cmd.Params(2)))
                        If Not My.Computer.FileSystem.FileExists(FullPath) Then Err.Raise(-1, , "Файл не существует")
                        .ConfPath = FullPath
                    End With
                    ProcessMangosConf(Apps(Apps.Length - 1))
                    'Case "appping"
                    '    With Apps(Apps.Length - 1)
                    '        .PingEnable = True
                    '        .PingTime = Cmd.Params(0)
                    '        .PingAttempts = Cmd.Params(1)
                    '    End With
                Case "appstartconfirm"
                    If Trim(Cmd.Params(0)) = "" Then Err.Raise(-1, , "Некорректное значение параметра")
                    If Cmd.Params(0).Length > MaxLogStrLength Then Err.Raise(-1, , "Значение параметра слишком длинное")
                    Apps(Apps.Length - 1).StartConfirm = Cmd.Params(0)
                Case "appstarttimeout"
                    If Apps(Apps.Length - 1).StartConfirm = "" Then Err.Raise(-1, , "Сначала необходимо указать AppStartConfirm")
                    Apps(Apps.Length - 1).StartTime = Cmd.Params(0)
                Case "appstartattempts"
                    If Apps(Apps.Length - 1).StartConfirm = "" Then Err.Raise(-1, , "Сначала необходимо указать AppStartConfirm")
                    Apps(Apps.Length - 1).StartAttempts = Cmd.Params(0)
                Case "apptime"
                    Apps(Apps.Length - 1).BeginHour = Cmd.Params(0)
                    Apps(Apps.Length - 1).EndHour = Cmd.Params(1)
                Case "apprestartinterval"
                    Apps(Apps.Length - 1).RestartInterval = Cmd.Params(0)

                Case ""

                Case Else
                    Err.Raise(-1, , "Неизвестная команда: " & Cmd.CommmandName)
            End Select
        Loop
        ' Закрываем файл
        FileClose(FileNumber)
        ' Выводим предупреждения
        For Each I As CApplication In Apps
            If I.StartConfirm = "" Then
                OutLog(Target(I.Name), NewCData("Настоятельно рекомендуется указать AppStartConfirm!", cfontWarning))
            End If
        Next
        ' Выводим потдверждение
        OutLog(NewCData("Файл конфигурации загружен", cfontNormal), TimeStamp)
        OutLog()
        Return True
        Dim ErrMsg As String
E1:     FileClose(FileNumber)
        OutLog(NewCData("Не удалось открыть файл конфигурации:", cfontError))
        OutLog(NewCData(ConfigurationFile, cfontNormal))
        OutLog()
        OutLog(NewCData(Err.Description, cfontWarning))
        OutLog()
        Return False
E2:     FileClose(FileNumber)
        OutLog(NewCData("Ошибка в файле конфигурации, строка " & StrNum, cfontError))
        OutLog(NewCData(ConfStr, cfontNormal))
        OutLog()
        OutLog(NewCData(Err.Description, cfontWarning))
        OutLog()
        Return False
    End Function

    Private Sub ConfigureMysqlSession(ByVal ConnectStr As String, ByRef objMysqlSession As CMysqlSession, ByVal LogAppName As String, ByVal PingTime As Integer)
        If ConnectStr = "" Then Return
        Dim SessionData As ConnectionString = ProcessConnectionString(ConnectStr)
        objMysqlSession = New CMysqlSession
        objMysqlSession.LogAppName = LogAppName
        objMysqlSession.MysqlHost = SessionData.Data(0)
        objMysqlSession.MysqlPort = SessionData.Data(1)
        objMysqlSession.MysqlUserName = SessionData.Data(2)
        objMysqlSession.MysqlPassword = SessionData.Data(3)
        objMysqlSession.MysqlDbName = SessionData.Data(4)
    End Sub

End Module
