﻿Module GUIConfiguration

    Private Const UserConfigFile As String = "MangoRestartGUI.conf"

    Private Const AlphaChannel As UInteger = 4278190080

    Public Sub LoadUserConfig()
        If UserConfigFile = "" Then Return
        On Error GoTo ErrorHandler
        Dim FileName As String = My.Computer.FileSystem.CombinePath(My.Application.Info.DirectoryPath, UserConfigFile)
        If Not My.Computer.FileSystem.FileExists(FileName) Then Return
        Dim FileNumber As Integer = FreeFile()
        FileOpen(FileNumber, UserConfigFile, OpenMode.Input, OpenAccess.Read, OpenShare.LockWrite)
        Dim ConfStr As String
        Dim Cmd As Command
        Dim StrNum As Integer = 0
        Do Until EOF(FileNumber)
            ConfStr = LineInput(FileNumber)
            Cmd = ProcessCommand(ConfStr, True, True, False)
            Select Case Cmd.CommmandName

                Case "windowleft"
                    MainWindow.Left = Cmd.Params(0)
                Case "windowtop"
                    MainWindow.Top = Cmd.Params(0)
                Case "windowwidth"
                    MainWindow.Width = Cmd.Params(0)
                Case "windowheight"
                    MainWindow.Height = Cmd.Params(0)
                Case "windowstate"
                    MainWindow.WindowState = Cmd.Params(0)

                Case "cfontnormal"
                    cfontNormal = NewCFont(Cmd.Params(0), ConvertColor(Cmd.Params(1)), Cmd.Params(2))
                Case "cfontwarning"
                    cfontWarning = NewCFont(Cmd.Params(0), ConvertColor(Cmd.Params(1)), Cmd.Params(2))
                Case "cfontmarked"
                    cfontMarked = NewCFont(Cmd.Params(0), ConvertColor(Cmd.Params(1)), Cmd.Params(2))
                Case "cfonterror"
                    cfontError = NewCFont(Cmd.Params(0), ConvertColor(Cmd.Params(1)), Cmd.Params(2))
                Case "cfonttimestamp"
                    cfontTimestamp = NewCFont(Cmd.Params(0), ConvertColor(Cmd.Params(1)), Cmd.Params(2))
                Case "cfontecho"
                    cfontEcho = NewCFont(Cmd.Params(0), ConvertColor(Cmd.Params(1)), Cmd.Params(2))
                Case "cfonttarget"
                    cfontTarget = NewCFont(Cmd.Params(0), ConvertColor(Cmd.Params(1)), Cmd.Params(2))
                Case "cfontchat"
                    cfontChat = NewCFont(Cmd.Params(0), ConvertColor(Cmd.Params(1)), Cmd.Params(2))
                Case "consolebackcolor"
                    ConsoleBackColor = Color.FromArgb(ConvertColor(Cmd.Params(0)))
                Case "txtinput"
                    InputBoxBackColor = Color.FromArgb(ConvertColor(Cmd.Params(2)))
                    InputBoxFont = NewCFont(Cmd.Params(0), ConvertColor(Cmd.Params(1)), Cmd.Params(3))

            End Select
        Loop
        FileClose(FileNumber)
        OutLog(NewCData("Настройки интерфейса загружены", cfontNormal))
        OutLog()
        Return
ErrorHandler:
        FileClose(FileNumber)
        InitUserInterface()
    End Sub

    Public Function ConvertColor(ByVal ColorStr As String) As Integer
        Dim UintColor As UInteger = "&H" & ColorStr
        UintColor = UintColor Or AlphaChannel
        Dim IntColor As Integer = 0
        memcpy_uint_int(IntColor, UintColor, 4)
        Return IntColor
    End Function

    Public Sub SaveUserData()
        On Error GoTo OnError
        Dim FileNumber As Integer = FreeFile()
        Dim FileName As String = My.Computer.FileSystem.CombinePath(My.Application.Info.DirectoryPath, UserConfigFile)
        ' Открываем файл
        FileOpen(FileNumber, FileName, OpenMode.Output, OpenAccess.Write, OpenShare.LockWrite)
        ' Записываем данные
        PrintLine(FileNumber, "# Состояние окна программы")
        Dim WS As Short = MainWindow.WindowState
        MainWindow.WindowState = FormWindowState.Normal
        PrintLine(FileNumber, "WindowLeft    " & MainWindow.Left)
        PrintLine(FileNumber, "WindowTop     " & MainWindow.Top)
        PrintLine(FileNumber, "WindowWidth   " & MainWindow.Width)
        PrintLine(FileNumber, "WindowHeight  " & MainWindow.Height)
        PrintLine(FileNumber, "WindowState   " & WS)
        PrintLine(FileNumber)
        PrintLine(FileNumber, "# Параметры консоли")
        PrintLine(FileNumber, "# cfont<Name> FontName Color Size")
        PrintLine(FileNumber, "# Color - шестнадцатиричное число в формате AARRGGBB")
        PrintLine(FileNumber, "cfontNormal     """ & cfontNormal.objFont.Name.Replace("""", """""") & """  """ & Hex(cfontNormal.ArgbColor) & """  " & cfontNormal.objFont.SizeInPoints)
        PrintLine(FileNumber, "cfontMarked     """ & cfontMarked.objFont.Name.Replace("""", """""") & """  """ & Hex(cfontMarked.ArgbColor) & """  " & cfontMarked.objFont.SizeInPoints)
        PrintLine(FileNumber, "cfontWarning    """ & cfontWarning.objFont.Name.Replace("""", """""") & """  """ & Hex(cfontWarning.ArgbColor) & """  " & cfontWarning.objFont.SizeInPoints)
        PrintLine(FileNumber, "cfontError      """ & cfontError.objFont.Name.Replace("""", """""") & """  """ & Hex(cfontError.ArgbColor) & """  " & cfontError.objFont.SizeInPoints)
        PrintLine(FileNumber, "cfontChat       """ & cfontChat.objFont.Name.Replace("""", """""") & """  """ & Hex(cfontChat.ArgbColor) & """  " & cfontChat.objFont.SizeInPoints)
        PrintLine(FileNumber, "cfontTarget     """ & cfontTarget.objFont.Name.Replace("""", """""") & """  """ & Hex(cfontTarget.ArgbColor) & """  " & cfontTarget.objFont.SizeInPoints)
        PrintLine(FileNumber, "cfontTimestamp  """ & cfontTimestamp.objFont.Name.Replace("""", """""") & """  """ & Hex(cfontTimestamp.ArgbColor) & """  " & cfontTimestamp.objFont.SizeInPoints)
        PrintLine(FileNumber, "cfontEcho       """ & cfontEcho.objFont.Name.Replace("""", """""") & """  """ & Hex(cfontEcho.ArgbColor) & """  " & cfontEcho.objFont.SizeInPoints)
        PrintLine(FileNumber, "# Цвет фона")
        PrintLine(FileNumber, "ConsoleBackColor  """ & Hex(ConsoleBackColor.ToArgb) & """")
        PrintLine(FileNumber, "# Шрифт и цвета поля ввода")
        PrintLine(FileNumber, "# txtInput FontName Color BackColor Size")
        PrintLine(FileNumber, "txtInput  """ & InputBoxFont.objFont.Name & """  """ & Hex(InputBoxFont.ArgbColor) & """  """ & Hex(InputBoxBackColor.ToArgb) & """  " & InputBoxFont.objFont.SizeInPoints)
        PrintLine(FileNumber)
        FileClose(FileNumber)
        ' Выводим подтверждение
        OutLog(NewCData("Файл пользовательских настроек обновлён", cfontNormal))
        Return
OnError:
        FileClose(FileNumber)
        OutLog(NewCData("Не удалось сохранить пользовательские данные", cfontError))
    End Sub

End Module
