﻿Module MangosConfProcessor

    Public Structure ConnectionString
        Dim Data() As String
    End Structure

    Sub ProcessMangosConf(ByRef objApp As CApplication)
        Dim FileNumber As Integer = FreeFile()
        Dim FileName As String = objApp.ConfPath
        Dim Opt As String
        Dim Val As String
        Dim Pos As Integer
        ' Открываем файл конфигурации
        FileOpen(FileNumber, FileName, OpenMode.Binary, OpenAccess.Read, OpenShare.LockWrite)
        ' Переменные для считывания из конфигурации
        Dim LogsDir As String = ""
        Dim LogFile As String = ""
        Do Until EOF(FileNumber)
            ' Считываем строку
            Opt = ""
            Dim X As Byte = 0
            Do
                If X >= 32 And X <= &H7F Then Opt &= Chr(X)
                FileGet(FileNumber, X)
            Loop Until EOF(FileNumber) Or X = 13 Or X = 10
            Opt = Trim(Opt)
            ' Проверяем, не пустая ли считанная строка, и не является ли она комментарием
            If Left(Opt, 1) = "#" Or Opt = "" Then Continue Do
            ' Проверяем, не является ли строка разделом (например "[MangosdConf]")
            If Left(Opt, 1) = "[" And Right(Opt, 1) = "]" Then Continue Do
            ' Определяем позицию знака равенства в строке
            Pos = InStr(Opt, "=")
            If Pos = 0 Then Err.Raise(-1, , "Ошибка в файле конфигурации: " & FileName)
            ' Выделяем из строки имя параметра и присваемое ему значение
            Val = Trim(Mid(Opt, Pos + 1))
            Opt = LCase(Trim(Left(Opt, Pos - 1)))
            ' Отсекаем кавычки в значении
            If Left(Val, 1) = """" And Right(Val, 1) = """" Then Val = Mid(Val, 2, Val.Length - 2)
            ' Обрабатываем считанные данные
            Select Case Opt
                Case "logsdir"
                    LogsDir = Val
                Case "logfile"
                    LogFile = Val
                Case "logtimestamp"
                    objApp.LogTimeStamp = Val
                    'Case "bindip"
                    '    If Val = "0.0.0.0" Then objApp.BindIP = "127.0.0.1" Else objApp.BindIP = Val
                    'Case "worldserverport"
                    '    objApp.PingType = CApplication.PingTypes.ptMangosd
                    '    objApp.Port = Val
                    'Case "realmserverport"
                    '    objApp.PingType = CApplication.PingTypes.ptRealmd
                    '    objApp.Port = Val
                Case "logindatabaseinfo"
                    objApp.LoginConnectionString = Val
                Case "worlddatabaseinfo"
                    objApp.WorldConnectionString = Val
                Case "characterdatabaseinfo"
                    objApp.CharactersConnectionString = Val
            End Select
        Loop
        ' Закрываем файл
        FileClose(FileNumber)
        ' Обрабатываем другие считанные параметры
        If LogFile <> "" Then
            LogsDir = My.Computer.FileSystem.CombinePath(objApp.WorkingDir, LogsDir)
            LogFile = My.Computer.FileSystem.CombinePath(LogsDir, LogFile)
            For Each I As CApplication In Apps
                If StrComp(I.LogFile, LogFile, CompareMethod.Text) = 0 Then
                    Err.Raise(-1, , "Сервера не могут использовать один и тот же лог-файл")
                End If
            Next
            objApp.LogFile = LogFile
        Else
            OutLog(Target(objApp.Name), NewCData("Настоятельно рекомендуется включить лог-файл!", cfontWarning))
        End If
    End Sub

    Function ProcessConnectionString(ByVal Str As String) As ConnectionString
        Dim CSData As New ConnectionString
        Dim I As Integer
        Dim J As Integer = 0
        Dim X As String
        ReDim CSData.Data(0)
        For I = 1 To Str.Length
            X = Mid(Str, I, 1)
            If X = ";" Then
                J += 1
                ReDim Preserve CSData.Data(J)
            Else
                CSData.Data(J) += X
            End If
        Next
        Return CSData
    End Function

End Module
