Public Class CApplication

    ' 
    Const AppWindowInitTime As Short = 10000

    '    realmd
    'Public RealmdPingPacket() As Byte = {0, 6, 31, 0, 87, 111, 87, 0, 2, 2, 3, 191, 28, 54, 56, 120, 0, 110, 105, 87, 0, 66, 71, 110, 101, 120, 0, 0, 0, 127, 0, 0, 1, 1, 32}

    '   
    Public Enum PingTypes As Short
        ptRealmd = 0
        ptMangosd = 1
    End Enum

    Public Enum KillMode As Short
        kmNone = 0
        kmOnce = 1
        kmForever = 2
    End Enum

    '  
    Public Name As String
    Public FilePath As String
    Public WorkingDir As String
    Public ConfPath As String
    '  
    Public LogFile As String
    Public LogNum As Integer
    Public LogTimeStamp As Boolean
    '  
    Public StartTime As UInt16
    Public StartAttempts As Byte
    Public StartConfirm As String
    ' 
    'Public BindIP As String = "127.0.0.1"
    'Public PingEnable As Boolean
    'Public Port As UInt16
    'Public PingType As PingTypes
    'Public PingTime As UInt16
    'Public PingAttempts As Byte = 3
    ' SQL-
    Public LoginConnectionString As String
    Public WorldConnectionString As String
    Public CharactersConnectionString As String
    Public LoginDb As Object = Nothing
    Public WorldDb As Object = Nothing
    Public CharactersDb As Object = Nothing
    ' ,     
    Public RestartInterval As Integer
    Public BeginHour As Byte
    Public EndHour As Byte
    '   ,   
    Public Proc As System.Diagnostics.Process
    Public StartTickCount As Long
    Public StopTickCount As Long
    Public Active As Boolean
    Public LogError As Boolean
    Public AppStarted As Boolean
    Public StartAttempt As Byte
    Public ExecutingCommand As Boolean
    Public WindowHandle As Integer
    Public LogData As String
    Public Checking As Boolean
    Private ThreadState As Boolean
    Private SqlOk As Boolean
    '   
    Private CAppThread As Thread
    '  
    Public MustCheck As Boolean
    Private MustKill As KillMode
    'Private MustPing As Boolean
    '      
    Private AsyncCompleted As Boolean = False
    Private AsyncState As IAsyncResult

    Private Sub CheckLog()
        If LogNum = 0 Then Return
        Dim FilePos As Integer = Seek(LogNum)
        Dim ReadLength As Integer = LOF(LogNum) - FilePos + 1
        If ReadLength < 0 Then
            Seek(LogNum, 1)
            ReadLength = LOF(LogNum)
        End If
        If ReadLength = 0 Then Return
        Dim NewData As String = Space(ReadLength)
        FileGet(LogNum, NewData)
        NewData = NewData.Replace(Chr(13), "")
        NewData = NewData.Replace(Chr(10), "")
        NewData = NewData.Replace(Chr(10), "")
        LogData = LogData & NewData
        FilePos = 0
        If StartConfirm <> "" Then
            If FindInLog(LogData, StartConfirm, FilePos) Then SetStarted()
        End If
        For Each ErrStr As String In LogStrings
            If FindInLog(LogData, ErrStr, FilePos) Then
                OutLog(Target(Name), NewCData("  -: " & ErrStr, cfontError))
                LogError = True
            End If
        Next
        If FilePos <> 0 Then LogData = Mid(LogData, FilePos)
        If LogData.Length > MaxLogStrLength - 1 Then
            LogData = Right(LogData, MaxLogStrLength - 1)
        End If
    End Sub

    Private Function FindInLog(ByVal LData As String, ByVal Str As String, ByVal MaxPos As Integer) As Boolean
        Dim Pos As Integer = InStr(LData, Str, CompareMethod.Text)
        If Pos > 0 Then
            Pos += Str.Length
            If MaxPos < Pos Then MaxPos = Pos
            Return True
        Else
            Return False
        End If
    End Function

    Private Sub Kill(ByVal sKillMode As KillMode)
        If Started() Then
            OutLog(Target(Name), NewCData("", cfontWarning), TimeStamp)
            FileClose()
            If WindowHandle = 0 Then GoTo 1
            PostMessage(WindowHandle, WM_CLOSE, 0, 0)
            Dim Tmr As Integer = My.Computer.Clock.TickCount + AppCloseTime
            Do
                If My.Computer.Clock.TickCount > Tmr Then
                    OutLog(Target(Name), NewCData(" ,  ", cfontError), TimeStamp)
1:                  On Error Resume Next
                    Proc.Kill()
                    On Error GoTo 0
                    Do
                        Thread.Sleep(ThreadWaitInterval)
                    Loop While Started()
                    Exit Do
                End If
                Thread.Sleep(ThreadWaitInterval)
            Loop While Started()
        End If
        LogError = False
        Active = False
        AppStarted = False
        If Not IsNothing(Proc) Then Proc.Close()
        If sKillMode = KillMode.kmForever Then
            OutLog(Target(Name), NewCData(" ", cfontMarked), TimeStamp)
            StartAttempt = 0
            ThreadState = False
            CloseSqlConnections()
            MustKill = KillMode.kmNone
            Thread.CurrentThread.Abort()
        End If
    End Sub

    Private Function Started() As Boolean
        'On Error Resume Next
        If Not Active Then Return False
        If Proc Is Nothing Then Return False
        Return Not Proc.HasExited
        'Dim objInstance As System.Diagnostics.Process = Process.GetProcessById(Proc.Id)
        'If Err.Number <> 0 Then
        ' Err.Clear()
        ' Return False
        'End If
        'Return True
    End Function

    Private Function GenerateLogFileName(ByVal D As Date) As String
        Dim I As Integer
        Dim TimeStr As String = "_" & CStr(D.Year) & "-" & Format(D.Month, "0#") & "-" & Format(D.Day, "0#") & "_" _
            & Format(D.Hour, "0#") & "-" & Format(D.Minute, "0#") & "-" & Format(D.Second, "0#")
        For I = LogFile.Length To 1 Step -1
            If Mid(LogFile, I, 1) = "." Then Return Left(LogFile, I - 1) & TimeStr & Mid(LogFile, I)
        Next
        Return LogFile & TimeStr
    End Function

    Private Sub Start()
        Dim TmrVal As Integer
        If StartAttempts <> 0 Then StartAttempt += 1
        OutLog(Target(Name), NewCData("" & StrAttempts(), cfontMarked), TimeStamp)
        If LogFile <> "" Then
            On Error Resume Next
            LogData = ""
            If LogNum > 0 Then FileClose(LogNum)
            LogNum = FreeFile()
            If Not LogTimeStamp Then
                If My.Computer.FileSystem.FileExists(LogFile) Then
                    My.Computer.FileSystem.DeleteFile(LogFile)
                    If My.Computer.FileSystem.FileExists(LogFile) Then
                        OutLog(Target(Name), NewCData("    -,   ", cfontError))
                        LogNum = 0
                    End If
                End If
            End If
            On Error GoTo 0
        Else
            LogNum = 0
        End If
        Dim STime As Date = Now
        Proc = New System.Diagnostics.Process
        Proc.StartInfo.FileName = FilePath
        Proc.StartInfo.WorkingDirectory = WorkingDir
        Proc.StartInfo.UseShellExecute = False
        Proc.StartInfo.Arguments = "-c " & ConfPath
        If Not Proc.Start() Then GoTo 10
        Active = True
        TmrVal = My.Computer.Clock.TickCount + AppWindowInitTime
        WindowHandle = 0
        Do
            If My.Computer.Clock.TickCount > TmrVal Then GoTo 10
            If Not Started() Then GoTo 10
            Thread.Sleep(ThreadWaitInterval)
            Proc.Refresh()
            WindowHandle = Proc.MainWindowHandle
        Loop While WindowHandle = 0
        SetWindowText(WindowHandle, Name & vbNullChar)
        If Not MainWindow.Visible Then Hide()
        Dim LogFileName As String = LogFile
        Dim J As Date
        If LogNum <> 0 Then
            Do While True
                If LogTimeStamp Then
                    J = STime
                    Do
                        LogFileName = GenerateLogFileName(J)
                        If My.Computer.FileSystem.FileExists(LogFileName) Then Exit Do
                        J = J.AddSeconds(1)
                    Loop While J <= Now
                End If
                If My.Computer.FileSystem.FileExists(LogFileName) Then Exit Do
                If My.Computer.Clock.TickCount > TmrVal Then
                    OutLog(Target(Name), NewCData("   -", cfontError))
                    GoTo 10
                End If
                If Not Started() Then GoTo 10
                Thread.Sleep(ThreadWaitInterval)
                If MustKill <> KillMode.kmNone Then Return
            Loop
            On Error Resume Next
            Err.Clear()
            FileOpen(LogNum, LogFileName, OpenMode.Binary, OpenAccess.Read, OpenShare.Shared)
            If Err.Number <> 0 Then
                FileClose(LogNum)   '   
                OutLog(Target(Name), NewCData("   -,   ", cfontError))
                LogNum = 0
            Else
                OutLog(Target(Name), NewCData("-: " & LogFileName, cfontNormal))
            End If
            On Error GoTo 0
        End If
        'If (Not PingEnable And (StartConfirm = "" Or LogFile = "")) Then SetStarted()
        If (StartConfirm = "" Or LogFile = "") Then SetStarted()
        StartTickCount = My.Computer.Clock.TickCount
        StopTickCount = StartTickCount + RestartInterval * 60000
        Return
10:     OutLog(Target(Name), NewCData("  " & StrAttempts(), cfontError))
        Dim sKM As KillMode = KillMode.kmOnce
        If StartAttempt >= StartAttempts And StartAttempts <> 0 Then sKM = KillMode.kmForever
        Kill(sKM)
    End Sub

    Private Function Analyse() As Boolean
        If Not Started() Then Return False
        CheckLog()
        If LogError Then Return False
        If Not Proc.Responding Then Return False
        Return True
    End Function

    Private Sub Check()
        Dim B, A, C As Short
        A = BeginHour
        B = EndHour
        If A <> B Then
            C = Hour(TimeOfDay)
            If (C >= B And C < A And B < A) Or ((C < A Or C >= B) And B > A) Then
                If Active Then
                    OutLog(Target(Name), NewCData(" ", cfontMarked), TimeStamp)
                    Kill(KillMode.kmOnce)
                End If
                Return
            End If
        End If
        If Not Analyse() Then
            If Active Then
                OutLog(Target(Name), NewCData(" ", cfontError), TimeStamp)
                ShowBalloon(" : " & Name)
                PlaySound(ServerCrashedSound)
            End If
            Kill(KillMode.kmOnce)
            SqlCheck()
            If Not SqlOk Then Return
            Start()
        End If
        If Started() And MustKill = KillMode.kmNone Then
            'If Not AppStarted And (StartConfirm = "" Or LogNum = 0) Then
            '    If Ping() Then SetStarted()
            'End If
            If StartTime > 0 Then
                If Not AppStarted And My.Computer.Clock.TickCount > StartTickCount + CLng(StartTime) * 1000 Then
                    OutLog(Target(Name), NewCData("   -" & StrAttempts(), cfontError))
                    Dim sKM As KillMode = KillMode.kmOnce
                    If StartAttempt >= StartAttempts And StartAttempts <> 0 Then sKM = KillMode.kmForever
                    Kill(sKM)
                    If StartAttempt >= StartAttempts Then OutLog(Target(Name), NewCData(" ", cfontError))
                    ShowBalloon(" : " & Name)
                End If
            End If
            If AppStarted And RestartInterval <> 0 Then
                If My.Computer.Clock.TickCount >= StopTickCount Then
                    OutLog(Target(Name), NewCData(" ", cfontNormal), TimeStamp)
                    PlaySound(ServerStartFailedSound)
                    Kill(KillMode.kmOnce)
                    MustCheck = True
                End If
            End If
        End If
    End Sub

    Private Sub SetStarted()
        If AppStarted Then Return
        AppStarted = True
        StartAttempt = 0
        OutLog(Target(Name), NewCData(" ", cfontNormal), TimeStamp)
        ShowBalloon(" : " & Name)
        PlaySound(ServerStartedSound)
    End Sub

    Private Function StrAttempts() As String
        If StartAttempts <> 0 Then
            StrAttempts = " ( " & StartAttempt & "  " & StartAttempts & ")"
        Else
            StrAttempts = ""
        End If
    End Function

    'Private Sub PingCheck()
    '    If Started() Then
    '        If AppStarted Then
    '            Dim Cnt As Byte = 0
    '            Do Until Ping()
    '                Cnt += 1
    '                OutLog("   ! ( " & Cnt & "  " & PingAttempts & ")", colorError, Name, colorTarget)
    '                If Cnt >= PingAttempts Then Exit Do
    '                Wait(TimeBetweenPings)
    '            Loop
    '            If Cnt >= PingAttempts Then
    '                Kill(KillMode.kmOnce)
    '            ElseIf Cnt <> 0 Then
    '                OutLog("  ", colorNormal, Name, colorTarget)
    '            End If
    '        End If
    '    End If
    'End Sub

    Private Sub SqlCheck()
        Dim SqlOkState As Boolean = SqlOk
        SqlOk = True
        If Not LoginDb Is Nothing Then
            LoginDb.CheckConnection()
            If Not LoginDb.Connected Then SqlOk = False
            If Not WorldDb Is Nothing Then
                WorldDb.CheckConnection()
                If Not WorldDb.Connected Then SqlOk = False
            End If
            If Not CharactersDb Is Nothing Then
                CharactersDb.CheckConnection()
                If Not CharactersDb.Connected Then SqlOk = False
            End If
        End If
        If SqlOk And Not SqlOkState Then MustCheck = True
        'If SqlOkState And Not SqlOk Then MustPing = True
    End Sub

    Private Sub CloseSqlConnections()
        If Not LoginDb Is Nothing Then LoginDb.CloseConnection()
        If Not WorldDb Is Nothing Then WorldDb.CloseConnection()
        If Not CharactersDb Is Nothing Then CharactersDb.CloseConnection()
    End Sub

    Private Sub CAppThreadProc()
        On Error GoTo ErrorHandler
        Dim CheckTmr As Integer = 0
        Dim PingTmr As Integer = 0
        Dim SqlCheckTmr As Integer = 0
        Do While True
            If My.Computer.Clock.TickCount >= CheckTmr Or MustCheck Then
                MustCheck = False
                Check()
                CheckTmr = My.Computer.Clock.TickCount + CheckInterval
            End If
            'If My.Computer.Clock.TickCount >= PingTmr Or MustPing Then
            '    MustPing = False
            '    PingCheck()
            '    PingTmr = My.Computer.Clock.TickCount + PingInterval
            'End If
            If My.Computer.Clock.TickCount >= SqlCheckTmr Then
                SqlCheck()
                If SqlOk Then
                    PingTmr = My.Computer.Clock.TickCount + PingInterval
                Else
                    PingTmr = My.Computer.Clock.TickCount + CheckInterval
                End If
            End If
            If MustKill <> KillMode.kmNone Then
                Kill(MustKill)
                MustKill = KillMode.kmNone
            End If
            Thread.Sleep(ThreadSleepInterval)
        Loop
ErrorHandler:
        HandleCrash(Err, Err.GetException, "  CApplication: " & Name)
        Kill(KillMode.kmOnce)
        MustKill = KillMode.kmNone
        Err.Raise(Err.Number, Err.Source, Err.Description, Err.HelpFile, Err.HelpContext)
    End Sub

    'Private Sub AsyncHandler(ByVal ar As System.IAsyncResult)
    '    If ar.IsCompleted Then AsyncCompleted = True
    'End Sub

    '    Private Function Ping() As Boolean
    '        Dim Sock As New Net.Sockets.Socket(Net.Sockets.AddressFamily.InterNetwork, Net.Sockets.SocketType.Stream, Net.Sockets.ProtocolType.Tcp)
    '        If Not PingEnable Then Return True
    '        Dim Tmr As Long = My.Computer.Clock.TickCount + PingTime
    '        AsyncCompleted = False
    '        Sock.BeginConnect(BindIP, Port, New System.AsyncCallback(AddressOf AsyncHandler), AsyncState)
    '        Do Until AsyncCompleted
    '            If My.Computer.Clock.TickCount > Tmr Then
    '                Sock.Close()
    '                Return False
    '            End If
    '            Thread.Sleep(ThreadWaitInterval)
    '        Loop
    '        If Not Sock.Connected Then Return False
    '        If PingType = PingTypes.ptRealmd Then
    '            Sock.BeginSend(RealmdPingPacket, 0, 35, Net.Sockets.SocketFlags.None, New System.AsyncCallback(AddressOf AsyncHandler), AsyncState)
    '        End If
    '        Do While Sock.Available = 0
    '            If My.Computer.Clock.TickCount > Tmr Then GoTo 1
    '            Thread.Sleep(ThreadWaitInterval)
    '        Loop
    '1:      Sock.Close()
    '        Return True
    '    End Function

    Private Sub Restart()
        If Active Then OutLog(Target(Name), NewCData("", cfontMarked), TimeStamp)
        Kill(KillMode.kmOnce)
        MustCheck = True
    End Sub

    ' ----------------------------------------------------------------------------------
    ' ---------------        ---------------
    ' ----------------------------------------------------------------------------------

    Public Sub ThreadStart()
        If ThreadState Then Exit Sub
        ThreadState = True
        CAppThread = New Thread(AddressOf CAppThreadProc)
        CAppThread.Start()
    End Sub

    Public Sub SafeRestart()
        If Active Then OutLog(Target(Name), NewCData("", cfontMarked), TimeStamp)
        SafeKill(KillMode.kmOnce)
        MustCheck = True
    End Sub

    Public Sub Show()
        ShowWindow(WindowHandle, 1)
    End Sub

    Public Sub Hide()
        ShowWindow(WindowHandle, 0)
    End Sub

    Public Sub SafeKill(ByVal sKillMode As KillMode)
        If Not ThreadState Then Exit Sub
        Do Until MustKill = KillMode.kmNone
            My.Application.DoEvents()
        Loop
        MustKill = sKillMode
        Do Until MustKill = KillMode.kmNone
            My.Application.DoEvents()
        Loop
    End Sub

End Class
