﻿Module ExceptionHandler

    Private Delegate Sub deleg_HandleCrash(ByVal Crash As ErrObject, ByVal Except As Exception, ByVal AdditionalInfo As String)

    Public Sub HandleCrash(ByVal Crash As ErrObject, ByVal Except As Exception, ByVal AdditionalInfo As String)
        Dim dHC As New deleg_HandleCrash(AddressOf Safe_HandleCrash)
        MainWindow.BeginInvoke(dHC, Crash, Except, AdditionalInfo)
    End Sub

    Private Sub Safe_HandleCrash(ByVal Crash As ErrObject, ByVal Except As Exception, ByVal AdditionalInfo As String)
        On Error Resume Next
        OutLog()
        OutLog(NewCData("СБОЙ MANGORESTART!!!", cfontError), TimeStamp)
        ShowBalloon("СБОЙ MANGORESTART!!!")
        OutLog()
        WriteCrashDump(Crash, Except, AdditionalInfo)
        PlaySound(MangoRestartCrashedSound)
        ShutdownAll(False, False)
        OutLog()
    End Sub

    Private Sub WriteCrashDump(ByVal Crash As ErrObject, ByVal Except As Exception, ByVal AdditionalInfo As String)
        On Error Resume Next
        Dim CrashDump As String = GenerateCrashDumpFileName(My.Computer.Clock.LocalTime)
        Dim FileName As String = My.Computer.FileSystem.CombinePath(My.Application.Info.DirectoryPath, CrashDump)
        Dim FileNum As Integer = FreeFile()
        FileOpen(FileNum, FileName, OpenMode.Append, OpenAccess.Write, OpenShare.LockWrite)
        If Err.Number <> 0 Then
            OutLog(NewCData("Не удалось записать креш-дамп: " & FileName, cfontError))
            Err.Clear()
            Return
        End If
        PrintLine(FileNum, "************************************")
        PrintLine(FileNum, "**     Креш-дамп MangoRestart     **")
        PrintLine(FileNum, "************************************")
        PrintLine(FileNum)
        PrintLine(FileNum, "Версия: " & VersionString)
        PrintLine(FileNum)
        PrintLine(FileNum, "Время GMT: " & My.Computer.Clock.GmtTime)
        PrintLine(FileNum, "Локальное время: " & My.Computer.Clock.LocalTime)
        PrintLine(FileNum)
        If Crash.Number <> 0 Then
            PrintLine(FileNum, "Номер ошибки: " & Crash.Number)
        End If
        PrintLine(FileNum, "Описание сбоя: " & Except.Message)
        PrintLine(FileNum)
        PrintLine(FileNum, "Содержимое стека:")
        PrintLine(FileNum, Except.StackTrace)
        PrintLine(FileNum)
        PrintLine(FileNum, "Место сбоя: " & Except.TargetSite.Module.Name)
        PrintLine(FileNum, "Источник сбоя: " & Except.Source)
        If AdditionalInfo <> "" Then
            PrintLine(FileNum)
            PrintLine(FileNum, "Дополнительная информация: " & AdditionalInfo)
        End If
        PrintLine(FileNum)
        PrintLine(FileNum, "*******************************")
        PrintLine(FileNum, "**     Файл конфигурации     **")
        PrintLine(FileNum, "*******************************")
        PrintLine(FileNum)
        PrintLine(FileNum, ConfigDump)
        PrintLine(FileNum)
        PrintLine(FileNum, "*****************")
        PrintLine(FileNum, "**     Лог     **")
        PrintLine(FileNum, "*****************")
        PrintLine(FileNum)
        PrintLine(FileNum, frmMain.txtConsole.Text.Replace(Chr(10), vbCrLf))
        FileClose(FileNum)
        If Err.Number = 0 Then
            OutLog(NewCData("Креш-дамп успешно записан: " & FileName, cfontWarning))
            OutLog(NewCData("Пожалуйста, опишите найденный баг и выложите креш-дамп по адресу:", cfontNormal))
            OutLog(NewCData(SupportAddress, cfontNormal))
        Else
            OutLog(NewCData("Не удалось правильно записать креш-дамп", cfontWarning))
            OutLog(NewCData("Возможно файл """ & FileName & """ поврежден", cfontWarning))
        End If
        OutLog()
    End Sub

    Private Function GenerateCrashDumpFileName(ByVal Time As Date) As String
        Return "Crash_" & Format(Time.Day, "0#") & "." & Format(Time.Month, "0#") & "." & Time.Year & "_" & Format(Time.Hour, "0#") & "-" & Format(Time.Minute, "0#") & "-" & Format(Time.Second, "0#") & ".log"
    End Function

End Module
