﻿Public Class CMysqlSession

    Private Const MYSQL_OPT_CONNECT_TIMEOUT As Integer = 0
    Private Const MYSQL_OPT_COMPRESS As Integer = 1
    ' Функции для работы с MySQL
    Private Declare Sub mysql_close Lib "libmySQL" (ByVal hMYSQL As Integer)
    Private Declare Function mysql_init Lib "libmySQL" (ByVal hMYSQL As Integer) As Integer
    Private Declare Function mysql_options Lib "libmySQL" (ByVal hMYSQL As Integer, ByVal lOption As Integer, ByVal sArg As String) As Integer
    Private Declare Function mysql_ping Lib "libmySQL" (ByVal hMYSQL As Integer) As Integer
    Private Declare Function mysql_real_connect Lib "libmySQL" (ByVal hMYSQL As Integer, ByVal sHostName As String, ByVal sUserName As String, ByVal sPassword As String, ByVal sDbName As String, ByVal lPortNum As Integer, ByVal sSocketName As String, ByVal lFlags As Integer) As Integer
    ' Дополнительные параметры
    Public LogAppName As String
    ' Параметры MySQL-сервера
    Public MysqlHost As String
    Public MysqlPort As UInt16
    Public MysqlPingTime As UInt16
    Public MysqlChecking As Boolean
    Public MysqlUserName As String
    Public MysqlPassword As String
    Public MysqlDbName As String
    ' Состояние MySQL-сервера
    Private MysqlHandle As Integer
    Public Connected As Boolean

    Private Sub ConfigureMysql()
        mysql_options(MysqlHandle, MYSQL_OPT_COMPRESS, 0)
        mysql_options(MysqlHandle, MYSQL_OPT_CONNECT_TIMEOUT, MysqlPingTime)
    End Sub

    Private Function InitMysql() As Boolean
        MysqlHandle = 0
        MysqlHandle = mysql_init(MysqlHandle)
        ConfigureMysql()
        Return (mysql_real_connect(MysqlHandle, MysqlHost, MysqlUserName, MysqlPassword, MysqlDbName, MysqlPort, "", 0) <> 0)
    End Function

    Private Function PingMysql() As Boolean
        Return (mysql_ping(MysqlHandle) = 0)
    End Function

    Public Sub CloseConnection()
        If Not Connected Then Return
        mysql_close(MysqlHandle)
        OutLog(Target(LogAppName), NewCData("MySQL отключен: " & MysqlDbName, cfontWarning))
        Connected = False
    End Sub

    Public Sub CheckConnection()
        Dim Cnt As Byte
        If MysqlHost = "" Then Exit Sub
        If MysqlChecking Then
            Do While MysqlChecking
                My.Application.DoEvents()
            Loop
            Exit Sub
        End If
        MysqlChecking = True
        If Connected Then
            Cnt = 0
            If Not PingMysql() Then
                mysql_close(MysqlHandle)
                If Not InitMysql() Then
                    OutLog(Target(LogAppName), NewCData("MySQL-подключение потеряно: " & MysqlDbName, cfontError))
                    mysql_close(MysqlHandle)
                    Connected = False
                End If
            End If
        Else
            If InitMysql() Then
                Connected = True
                OutLog(Target(LogAppName), NewCData("MySQL подключен: " & MysqlDbName, cfontWarning))
                CheckAppsNow()
            End If
        End If
        MysqlChecking = False
    End Sub


End Class
