Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Friend Class frmMain
    Inherits System.Windows.Forms.Form

    Public Delegate Sub deleg_Restart()

    Public Sub cmdExit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdExit.Click
        ShutdownAll(True)
    End Sub

    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If e.CloseReason = CloseReason.UserClosing Then
            e.Cancel = True
            HideWindows()
        Else
            ShutdownAll(True)
        End If
    End Sub

    Private Sub frmMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        MainWindow = Me
        Dim Capt As String
        Capt = My.Application.Info.Title & " " & VersionString
        ChDrive(My.Application.Info.DirectoryPath)
        ChDir(My.Application.Info.DirectoryPath)
        InitGlobals()
        InitUserInterface()
        Me.Text = Capt
        TrayIcon.Text = Capt
        TrayIcon.Icon = Me.Icon
        CommandSystemStart()
        If Not LoadSettings() Then Return
        LoadUserConfig()
        OutLog(NewCData(Capt & " by " & My.Application.Info.CompanyName, cfontWarning))
        OutLog()
        OutLog(NewCData("   :", cfontNormal))
        OutLog(NewCData(SupportAddress, cfontNormal))
        ShowCommandList()
        InitThreads()
    End Sub

    Public Sub Restart()
        ShutdownAll(False, False, False)
        OutLog()
        OutLog(NewCData("------------------------------------------", cfontNormal))
        OutLog()
        InitGlobals()
        LoadSettings()
        InitThreads()
    End Sub

    Private Sub TrayIcon_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TrayIcon.MouseClick
        If e.Button = Windows.Forms.MouseButtons.Left Then ShowWindows()
    End Sub

    Private Sub cmdShow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdShow.Click
        ShowWindows()
    End Sub

    Private Sub cmdHide_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdHide.Click
        HideWindows()
    End Sub

    Private Sub txtInput_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtInput.KeyDown
        If e.KeyCode = Keys.Enter And txtInput.Text <> "" Then
            Dim Cmd As String = txtInput.Text
            txtInput.Text = ""
            PutCommandToQueue(Cmd)
            e.SuppressKeyPress = True
        End If
    End Sub

    Private Sub txtConsole_LinkClicked(ByVal sender As Object, ByVal e As System.Windows.Forms.LinkClickedEventArgs) Handles txtConsole.LinkClicked
        On Error Resume Next
        Shell("explorer """ & e.LinkText & """", AppWinStyle.NormalFocus)
    End Sub
End Class